	GameTimeFrame:SetParent(nil)
	MiniMapWorldMapButton:SetParent(nil)
	MinimapZoomIn:SetParent(nil)
	MinimapZoomOut:SetParent(nil)
	MiniMapTracking:SetParent(nil)
	MiniMapTrackingButton:SetParent(nil)
	MiniMapMailFrame:SetParent(nil)
	MiniMapVoiceChatFrame:SetParent(nil)
	MinimapCluster:SetParent(nil)
	MinimapBackdrop:SetParent(nil)
	GameTimeFrame:Hide()
	MiniMapWorldMapButton:Hide()
	MinimapZoomIn:Hide()
	MinimapZoomOut:Hide()
	MiniMapTracking:Hide()
	MiniMapTrackingButton:Hide()
	MiniMapMailFrame:Hide()
	MiniMapVoiceChatFrame:Hide()
	MinimapBorderTop:Hide()
	MinimapBorder:Hide()
	MinimapBackdrop:Hide()
	MinimapCluster:Hide()



local TexturePath = "Interface\\AddOns\\Dominos_MINIMAP\\Prepare\\Icons\\"

local function GetScript(newButton, oldButton, script)
	newButton:SetScript(script, function(self, arg1)
		 oldButton:GetScript(script)(newButton, arg1)
	end)
end
local HideOldButtons = CreateFrame("Frame")
HideOldButtons:Hide()
local function ConvertButton(oldButton, parent, drop, texture, texcoords, scripts, kind)
	local b = CreateFrame(kind or "Button", "New_"..oldButton:GetName(), parent, "New_MinimapButtonTemplate")
	b.icon:SetTexture(texture)
	if texcoords then
		b.icon:SetTexCoord(unpack(texcoords))
	end
		b:SetFontString(b.text)
		
	if drop then
		b.drop = CreateFrame("Frame", b:GetName().."DropDown", b, "UIDropDownMenuTemplate")	
		
	end
	
	b.tooltipText = oldButton.tooltipText
	b.newbieText = oldButton.newbieText
	if scripts then
		for i = 1, #scripts do
			GetScript(b, oldButton, scripts[i])
		end
	end
	oldButton:SetParent(HideOldButtons)
	
	oldButton:SetScript("OnShow", function(self, arg1)
		 --self:Hide()
	end)
	
	
	
	return b
end

local New_Minimap_Buttons = {}
do
local cal = ConvertButton(GameTimeFrame, UIParent, nil, TexturePath.."cal.blp", nil, {"OnLoad", "OnEnter", "OnLeave", "OnEvent", "OnUpdate", "OnClick"})
cal.pendingCalendarInvites = 0
cal:GetScript("OnLoad")(calendar)

function GameTimeFrame:SetText(day)
	cal.text:SetText(day)
end
cal:RegisterEvent("CALENDAR_UPDATE_EVENT");
cal:SetScript("OnEvent", function(self, event, ...)
	if ( event == "CALENDAR_UPDATE_PENDING_INVITES" or event == "PLAYER_ENTERING_WORLD" or event == "CALENDAR_UPDATE_EVENT") then
		local pendingCalendarInvites = CalendarGetNumPendingInvites();
		if ( pendingCalendarInvites > self.pendingCalendarInvites ) then
			if ( not CalendarFrame or (CalendarFrame and not CalendarFrame:IsShown()) ) then
				self.CIT:Show();
				self.CIG:Show();
				self.flashInvite = true;
				self.pendingCalendarInvites = pendingCalendarInvites;
			end
		elseif ( pendingCalendarInvites == 0 ) then
			self.CIT:Hide();
			self.CIG:Hide();
			self.flashInvite = false;
			self.pendingCalendarInvites = 0;
		end
		GameTimeFrame_SetDate();
	elseif ( event == "CALENDAR_EVENT_ALARM" ) then
		local title, hour, minute = ...;
		local info = ChatTypeInfo["SYSTEM"];
		DEFAULT_CHAT_FRAME:AddMessage(format(CALENDAR_EVENT_ALARM_MESSAGE, title), info.r, info.g, info.b, info.id);
		--UIFrameFlash(GameTimeCalendarEventAlarmTexture, 1.0, 1.0, 6);
	end
end)
cal.CIT = cal:CreateTexture(cal:GetName().."CalendarInvitesTexture", "ARTWORK")
cal.CIT:SetSize(28, 32)
cal.CIT:SetPoint("Center")
cal.CIT:SetTexture("Interface/Calendar/EventNotification")
cal.CIT:SetTexCoord(.03125, .6484375, .03125, .8671875)
cal.CIT:Hide()
cal.CIG = cal:CreateTexture(cal:GetName().."CalendarInvitesGlow", "ARTWORK")
cal.CIG:SetSize(48, 48)
cal.CIG:SetPoint("Center")
cal.CIG:SetTexture("Interface/Calendar/EventNotificationGlow")
cal.CIG:Hide()
cal.CIG:SetBlendMode("ADD")
tinsert(New_Minimap_Buttons, cal) 
end

local map = ConvertButton(MiniMapWorldMapButton, UIParent, nil, TexturePath.."map.blp", nil, {"OnLoad", "OnEnter", "OnLeave", "OnEvent", "OnClick"})
tinsert(New_Minimap_Buttons, map) 

local mail = ConvertButton(MiniMapMailFrame, UIParent, nil, "Interface/Icons/INV_Letter_15", nil, {"OnLoad", "OnEnter", "OnLeave", "OnEvent"})
mail:GetScript("OnLoad")(mail)
mail:RegisterEvent("MAIL_CLOSED");
mail:RegisterEvent("CLOSE_INBOX_ITEM");
mail:Hide()
mail:SetScript("OnEvent", function(self, event)
	if  MiniMapMailFrame:IsShown() then
		mail:Show()
	else
		mail:Hide()
	end
end)
MiniMapMailIcon:Hide()
MiniMapMailBorder:Hide()
MiniMapMailFrame:EnableMouse(false)
tinsert(New_Minimap_Buttons, mail) 



local track = ConvertButton(MiniMapTrackingButton, UIParent, 1, TexturePath.."track.blp", nil, {"OnLoad", "OnEvent", "OnClick", "OnMouseDown", "OnMouseUp", "OnEnter", "OnLeave"})

local GetRelPos = function(self)
	local width, height = GetScreenWidth()/self:GetScale(), GetScreenHeight()/self:GetScale();
	local x, y = self:GetCenter()
	local xOffset, yOffset
	local Hori = (x > width/2) and 'RIGHT' or 'LEFT'
	if Hori == 'RIGHT' then
		xOffset = self:GetRight() - width
	else
		xOffset = self:GetLeft()
	end
	local Vert = (y > height/2) and 'TOP' or 'BOTTOM'
	if Vert == 'TOP' then
		yOffset = self:GetTop() - height
	else
		yOffset = self:GetBottom()
	end
	return Vert, Hori, xOffset, yOffset
end

local function SelectProperSide(self)
	local width = GetScreenWidth()
	
	local Vert, Hori, xOffset, yOffset = GetRelPos(self)
	local vert 
	
	if Vert == "TOP" then
		vert = "BOTTOM"
	elseif Vert == "BOTTOM" then
		vert = "TOP"
	end
	
	return Vert..Hori, vert..Hori
end

track:SetScript("OnClick", function(self, arg1)
	ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self:GetName(), 0, -5);
	DropDownList1:ClearAllPoints()
	
	local p1, p2 = SelectProperSide(self)
	
	DropDownList1:SetPoint(p1, self, p2)
	PlaySound("igMainMenuOptionCheckBoxOn");
end)
tinsert(New_Minimap_Buttons, track) 

local zoomin = ConvertButton(MinimapZoomIn, UIParent, nil, TexturePath.."plus.blp", nil, {"OnClick", "OnEnter", "OnLeave"}, "CheckButton")
tinsert(New_Minimap_Buttons, zoomin) 
local zoomout = ConvertButton(MinimapZoomOut, UIParent, nil, TexturePath.."minus.blp", nil, {"OnClick", "OnEnter", "OnLeave"},  "CheckButton")
tinsert(New_Minimap_Buttons, zoomout) 

Minimap:SetScript("OnMouseWheel", function(self, arg1)
	if (self:GetZoom()+arg1)<0 then
		arg1 = 0
	end
	self:SetZoom(self:GetZoom()+arg1)
		zoomin:GetPushedTexture():Hide()
		zoomout:GetPushedTexture():Hide()
		zoomout:Enable();
		zoomin:Enable();
	if(self:GetZoom() == 0) then
		zoomout:GetPushedTexture():Show()
		zoomout:Disable();
	elseif (self:GetZoom() == (self:GetZoomLevels() - 1)) then
		zoomin:GetPushedTexture():Show()
		zoomin:Disable();
	end
end)



zoomin:SetScript("OnClick", function()
	Minimap:GetScript("OnMouseWheel")(Minimap, 1)
end)

zoomout:SetScript("OnClick", function()
	Minimap:GetScript("OnMouseWheel")(Minimap, -1)
end)



local Minimap_Button_Container = CreateFrame("Frame", nil, UIParent)
Minimap_Button_Container:SetPoint("Center")
local size
for i, b in pairs(New_Minimap_Buttons) do
	size = 140/6
	Minimap_Button_Container:SetSize(size,size*i)
	b:SetParent(Minimap_Button_Container)
	b:SetPoint("Top", Minimap_Button_Container , 0, -(size*(i)-size))
	b:SetSize(size, size)
end

local MinimapContainer = CreateFrame("Frame", "MinimapContainer", UIParent)
MinimapContainer:SetSize(140 +size, 140 + size)

local MinimapMasque = CreateFrame("Button", "MinimapMasque", MinimapContainer, "New_MinimapCover")

MinimapContainer.mini = CreateFrame("Frame", nil, MinimapContainer)
MinimapContainer.mini:SetSize(140, 140)

MinimapMasque:SetFrameLevel(4)
MinimapMasque:SetSize(140, 140)
MinimapMasque:SetPoint("Center", MinimapContainer.mini)
Minimap:SetParent(MinimapContainer)

local f = CreateFrame("Frame")
f:SetAllPoints(MinimapMasqueIcon)
Minimap:ClearAllPoints()
Minimap:SetPoint("Center", f)
f:SetScript("OnSizeChanged", function(self, w, h)
	Minimap:SetScale(((h) / 105 ) / MinimapContainer:GetParent():GetScale())
end)

MinimapMasque:EnableMouse(false)
Minimap:SetFrameLevel(MinimapMasque:GetFrameLevel() - 1)

function Minimap:GetContainer(self, Variable)
	MinimapContainer:SetParent(self)
	MinimapContainer:ClearAllPoints()
	MinimapContainer:SetPoint("CENTER", self, "CENTER")

	if Variable and Variable.Masque then
		for i, b in pairs(New_Minimap_Buttons) do
			Variable:Masque("Minimap Icons", b)
		end
		Variable:Masque("Minimap", MinimapMasque)	
	end
	return MinimapContainer
end

function GetMinimapShape() return 'SQUARE' end

MinimapZoneTextButton:ClearAllPoints()
MinimapZoneTextButton:SetParent(MinimapContainer)

MinimapZoneTextButton:SetSize(140 +size, size)
MinimapZoneTextButton:RegisterForClicks("AnyDown")

MinimapZoneTextButton:SetBackdrop( {
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 10, edgeSize = 10,
			insets = { left = 3, right = 3, top = 3, bottom = 3} })
			MinimapZoneText:SetAllPoints(MinimapZoneTextButton)
Minimap:SetMaskTexture(TexturePath.."HoleMinimap.tga")		



local function ToggleButtons(vari)
	for i, b in pairs({Minimap:GetChildren()}) do
		if b:GetName()~="TimeManagerClockButton" then
			if vari then
				b:Hide()
			else
				b:Show()
			end
		end
	end
end


local Wait = CreateFrame("Frame")
Wait:RegisterEvent("PLAYER_ENTERING_WORLD")

function Minimap:Settings(Vari, Minimapscale)
	MinimapContainer.mini:ClearAllPoints()
	MinimapZoneTextButton:ClearAllPoints()
	Minimap_Button_Container:ClearAllPoints()
	
	MinimapContainer.mini:SetParent(MinimapContainer)
	MinimapZoneTextButton:SetParent(MinimapContainer)
	Minimap_Button_Container:SetParent(MinimapContainer)

	local place
	if Vari.TtB then
		place = "Top"
		MinimapZoneTextButton:SetPoint("Bottom")
	else
		place = "Bottom"
		MinimapZoneTextButton:SetPoint("Top")
	end
	
	if not Vari.LtR then
		MinimapContainer.mini:SetPoint(place.."Left", 0, 0)
		Minimap_Button_Container:SetPoint(place.."Right", MinimapContainer)
	else
		MinimapContainer.mini:SetPoint(place.."Right", 0, 0)
		Minimap_Button_Container:SetPoint(place.."Left", MinimapContainer)
	end
	
	MinimapMasque:SetScale(Minimapscale)
	
	MinimapZoneTextButton:SetScript("OnClick", function(self, btn)
		if btn == "RightButton" then
			if not Vari.TogButtons then
				Vari.TogButtons = true
			else
				Vari.TogButtons = nil
			end
			ToggleButtons(Vari.TogButtons)
		else
			ToggleFrame(Minimap_Button_Container)
			ToggleFrame(Minimap)
			ToggleFrame(MinimapMasque)
			PlaySound("igMiniMapOpen");
		end
	end)

	Wait:SetScript("OnEvent", function(self)
		self.time = 0
		Wait:SetScript("OnUpdate", function(self, time)
			self.time = self.time + .15
			if self.time > 1 then
				ToggleButtons(Vari.TogButtons)
				Wait:SetScript("OnUpdate", nil)
			end
		end)
	end)

	
end
