local DCLOCK = Dominos:NewModule('Clock')

local CLOCK = Dominos:CreateClass('Frame', Dominos.Frame)

function DCLOCK:Load()
	self.frame = CLOCK:New()
	self.frame:SetFrameStrata('LOW')

end

function DCLOCK:Unload()
	self.frame:Free()
end

function CLOCK:New()
	local f = self.super.New(self, 'Clock')
	if not f.value then
		f:SetFrameStrata('BACKGROUND')
	end
	f:Layout()
	f:Stuff()
	return f
end

function CLOCK:GetDefaults()
	return {
		scale = 1,
		point = 'CENTER',
		y = 0,
		x = 0,
	}
end

function CLOCK:Layout()

	if not self.clock then
	
	local clock = CreateFrame("Button","clock",self)
		clock:SetPoint("CENTER",self)
		self.clock = clock
	
	clock:SetAllPoints(self)
	

	clock:SetBackdrop( {
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	
		tile = true, tileSize = 10, edgeSize = 10,
	
		insets = { left = 3, right = 3, top = 3, bottom = 3} })
		self:SetBackdropColor()
	

	self.time = clock:CreateFontString(nil, "OVERLAY", "FriendsFont_Large")
	
	self.time:SetPoint("CENTER")
	
	self.time:SetTextColor(1,1,1)


		self:SetScript("OnUpdate", function(_,elapsed)
		
	self.time:SetText(GameTime_GetLocalTime(true))
		end)

 		local GameTooltip = GameTooltip
		clock:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(clock, "ANCHOR_TOP_RIGHT")
			if ( TimeManagerClockButton.alarmFiring ) then
			
	GameTooltip:AddLine("Click to turn off Alarm");
			else
			
	GameTime_UpdateTooltip();
			
	GameTooltip:AddLine(" ");
			
	GameTooltip:AddLine(GAMETIME_TOOLTIP_TOGGLE_CLOCK);
			end
	
		GameTooltip:Show()
		end)

		clock:SetScript("OnLeave", function(self)
			if ( self.checkAlarm and Settings.alarmEnabled ) then
			
	TimeManager_CheckAlarm(elapsed);
			end
			GameTooltip:Hide()
		end)
		clock:RegisterForClicks("AnyDown")
		clock:SetScript("OnClick", function(self,btn)
			if ( TimeManagerClockButton.alarmFiring ) then

				TimeManager_TurnOffAlarm();
			else
		
		TimeManager_Toggle();

			end

		end)

	end
end

function CLOCK:SetBackdropColor()
	self.sets.color = self.sets.color or {r = 0, g = 0, b = 0, a= 1}
	local sets = self.sets.color
	self.clock:SetBackdropColor(sets.r, sets.g, sets.b, sets.a)
end

function CLOCK:Stuff()

	if not self.sets.padding then
		self.sets.padding = 0

	end

	self:SetWidth(80 + self.sets.padding)
	self:SetHeight(30 + self.sets.padding)

	clock:ClearAllPoints()

	clock:SetPoint("CENTER",self)
	clock:SetHeight(30)
	clock:SetWidth(80)
end

local function CreatePaddingSlider(p)

	local s = p:NewSlider("Padding", -10, 90, 1, OnShow)
	s.OnShow = function(self)
		self:SetValue(self:GetParent().owner.sets.padding)
	end
	s.UpdateValue = function(self, value)
		local f = self:GetParent().owner
		f.sets.padding = value		

		f:Stuff()
	end
end

local function AddLayoutPanel(menu)
	local p = menu:NewPanel(LibStub('AceLocale-3.0'):GetLocale('Dominos-Config').Layout)
	CreatePaddingSlider(p)
	p:NewOpacitySlider()
	p:NewFadeSlider()
	p:NewScaleSlider()
end



local FontSelector = function(menu)
	local p = CreateFrame("Button", menu:GetName().."TextSelector", menu,"UIDropDownMenuButtonTemplate")
	p:SetPoint("Top", 0, -10)
	
	menu.height = menu.height + 30
end
	
function CLOCK:CreateMenu()
	local menu = Dominos:NewMenu(self.id)
	AddLayoutPanel(menu)
	self.menu = menu
end